﻿using System;
using System.Collections.Generic;
using System.Data.Objects;
using System.Linq;
using MvcApplication.Models;

namespace MvcApplication
{
    public class Room
    {
        public Room()
        {
            Talks = new List<Talk>();
        }
        public int Id { get; set; }
        public string Name { get; set; }
        public virtual ICollection<Talk> Talks { get; private set; }
    }
    public class Talk
    {
        public Talk()
        {
            Speakers = new List<Speaker>();
        }
        public int Id { get; set; }
        public string Title { get; set; }
        public DateTime When { get; set; }
        public int RoomId { get; set; }
        public virtual Room Room { get; set; }
        public virtual ICollection<Speaker> Speakers { get; private set; }
    }
    public class Speaker
    {
        public Speaker()
        {
            Talks = new List<Talk>();
        }
        public int Id { get; set; }
        public string Name { get; set; }
        public virtual ICollection<Talk> Talks { get; private set; }
    }
    public class Workshop : Talk
    {
        public int Length { get; set; }
    }
    
    }


