
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 08/10/2010 15:41:26
-- Generated from EDMX file: C:\Users\Julie\Documents\Visual Studio 2010\Projects\NDC\model\MvcApplication\Models\Model1.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [Conference];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK__Talks__RoomId__03317E3D]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Talks] DROP CONSTRAINT [FK__Talks__RoomId__03317E3D];
GO
IF OBJECT_ID(N'[dbo].[FK_TalkSpeaker_Speakers]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TalkSpeaker] DROP CONSTRAINT [FK_TalkSpeaker_Speakers];
GO
IF OBJECT_ID(N'[dbo].[FK_TalkSpeaker_Talks]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TalkSpeaker] DROP CONSTRAINT [FK_TalkSpeaker_Talks];
GO
IF OBJECT_ID(N'[dbo].[FK_Workshop_inherits_Talk]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Talks_Workshop] DROP CONSTRAINT [FK_Workshop_inherits_Talk];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Rooms]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Rooms];
GO
IF OBJECT_ID(N'[dbo].[Speakers]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Speakers];
GO
IF OBJECT_ID(N'[dbo].[Talks]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Talks];
GO
IF OBJECT_ID(N'[dbo].[Talks_Workshop]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Talks_Workshop];
GO
IF OBJECT_ID(N'[dbo].[TalkSpeaker]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TalkSpeaker];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Rooms'
CREATE TABLE [dbo].[Rooms] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NULL
);
GO

-- Creating table 'Speakers'
CREATE TABLE [dbo].[Speakers] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Talks'
CREATE TABLE [dbo].[Talks] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Title] nvarchar(max)  NOT NULL,
    [When] datetime  NOT NULL,
    [RoomId] int  NOT NULL
);
GO

-- Creating table 'Talks_Workshop'
CREATE TABLE [dbo].[Talks_Workshop] (
    [Length] int  NOT NULL,
    [Id] int  NOT NULL
);
GO

-- Creating table 'TalkSpeaker'
CREATE TABLE [dbo].[TalkSpeaker] (
    [Speakers_Id] int  NOT NULL,
    [Talks_Id] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Id] in table 'Rooms'
ALTER TABLE [dbo].[Rooms]
ADD CONSTRAINT [PK_Rooms]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Speakers'
ALTER TABLE [dbo].[Speakers]
ADD CONSTRAINT [PK_Speakers]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Talks'
ALTER TABLE [dbo].[Talks]
ADD CONSTRAINT [PK_Talks]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Talks_Workshop'
ALTER TABLE [dbo].[Talks_Workshop]
ADD CONSTRAINT [PK_Talks_Workshop]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Speakers_Id], [Talks_Id] in table 'TalkSpeaker'
ALTER TABLE [dbo].[TalkSpeaker]
ADD CONSTRAINT [PK_TalkSpeaker]
    PRIMARY KEY NONCLUSTERED ([Speakers_Id], [Talks_Id] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [RoomId] in table 'Talks'
ALTER TABLE [dbo].[Talks]
ADD CONSTRAINT [FK__Talks__RoomId__03317E3D]
    FOREIGN KEY ([RoomId])
    REFERENCES [dbo].[Rooms]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK__Talks__RoomId__03317E3D'
CREATE INDEX [IX_FK__Talks__RoomId__03317E3D]
ON [dbo].[Talks]
    ([RoomId]);
GO

-- Creating foreign key on [Speakers_Id] in table 'TalkSpeaker'
ALTER TABLE [dbo].[TalkSpeaker]
ADD CONSTRAINT [FK_TalkSpeaker_Speakers]
    FOREIGN KEY ([Speakers_Id])
    REFERENCES [dbo].[Speakers]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [Talks_Id] in table 'TalkSpeaker'
ALTER TABLE [dbo].[TalkSpeaker]
ADD CONSTRAINT [FK_TalkSpeaker_Talks]
    FOREIGN KEY ([Talks_Id])
    REFERENCES [dbo].[Talks]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TalkSpeaker_Talks'
CREATE INDEX [IX_FK_TalkSpeaker_Talks]
ON [dbo].[TalkSpeaker]
    ([Talks_Id]);
GO

-- Creating foreign key on [Id] in table 'Talks_Workshop'
ALTER TABLE [dbo].[Talks_Workshop]
ADD CONSTRAINT [FK_Workshop_inherits_Talk]
    FOREIGN KEY ([Id])
    REFERENCES [dbo].[Talks]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------