﻿using System;
using System.Collections.Generic;
using System.Data.Objects;
using System.Linq;
using System.Web;
using MvcApplication.Models;

namespace MvcApplication
{ 
    public class Repository
    {
        public Repository(IContext context  )
        {
            _context = context;
        }
        private IContext _context;

        public IContext Context
        {
            get { return _context; }
            set { _context = value; }
        }
       
        public Talk GetTalkById(int id)
        {
            return _context.Talks.Where(t => t.Id == id)
                .SingleOrDefault();
        }
        public List<Talk> GetAllTalks()
        {
            return _context.Talks.ToList();
        }

    }
    
    public interface IContext
    {
        IObjectSet<Talk> Talks { get; }
        IObjectSet<Speaker> Speakers { get; }
        IObjectSet<Room> Rooms { get; }
        int SaveChanges();
    }
}